//--------------------------------------------------------------------
// Criterion.mqh
//         MQL4.
//--------------------------------------------------------------- 1 --
//    .
//  :
// 10 -  Buy  
// 20 -  Sell 
// 11 -  Buy
// 21 -  Sell
// 0  -   
// -1 -    
//--------------------------------------------------------------- 2 --
//  :
extern string A5 = "";


extern int Tenkan=9;
extern int Kijun=26;
extern int Senkou=52;





//--------------------------------------------------------------- 3 --
int Criterion()                        //  
  {
   int trend_period=GetPeriod(t_trend_period); 
   int signal_period = GetPeriod(s_signal_period);
   int enter_period = GetPeriod(e_enter_period);
  
  
//--------------------------------------------------------------- 4 --
   //  . :

//--------------------------  --------------------   
 double LastHigh_W = iHigh(Symbol(),trend_period,1);
 double LastLow_W = iLow(Symbol(),trend_period,1);
 double LastClose_W = iClose(Symbol(),trend_period,1);
 
 double LastHigh2_W = iHigh(Symbol(),trend_period,2);
 double LastLow2_W = iLow(Symbol(),trend_period,2);
 double LastClose2_W = iClose(Symbol(),trend_period,2);
 
 PivotW1 = (LastHigh_W +LastLow_W +LastClose_W )/3.0;
 PivotW2 = (LastHigh2_W +LastLow2_W +LastClose2_W )/3.0;
 
 R1_W = (2.0*PivotW1)-LastLow_W;
 R2_W = PivotW1+(LastHigh_W  - LastLow_W );
 
 S1_W = (2.0*PivotW1)-LastHigh_W ;
 S2_W = PivotW1-(LastHigh_W  - LastLow_W );
 
 
//---------------------------  ---------------------------------------------- 
 
 double LastHigh_D = iHigh(Symbol(),signal_period,1);
 double LastLow_D = iLow(Symbol(),signal_period,1);
 double LastClose_D = iClose(Symbol(),signal_period,1);
 
 double LastHigh2_D = iHigh(Symbol(),signal_period,2);
 double LastLow2_D = iLow(Symbol(),signal_period,2);
 double LastClose2_D = iClose(Symbol(),signal_period,2);
 
 PivotD1 = (LastHigh_D+LastLow_D+LastClose_D)/3.0;
 PivotD2 = (LastHigh2_D+LastLow2_D+LastClose2_D)/3.0;
 
 R1_D = (2.0*PivotD1)-LastLow_D;
 R2_D = PivotD1+(LastHigh_D - LastLow_D);
 
 S1_D = (2.0*PivotD1)-LastHigh_D;
 S2_D = PivotD1-(LastHigh_D - LastLow_D);
 
  
 flet = MathAbs((PivotD1-PivotD2)/Point);


//---------------------------4-  ---------------------------------------------- 

 

double Tenkan_1 = iIchimoku (Symbol(), enter_period, Tenkan, Kijun, Senkou, MODE_TENKANSEN, 1);


//--------------------------------------------------------------- 5 --
   
   //   
     
   
    
 //          +       +   
   if (Mas_Tip[0]==0 && //        
        flet>=FiltrPivot && iClose(Symbol(), enter_period,1) > Tenkan_1 && 
            iClose(Symbol(), signal_period,1) > PivotD1 && 
                  iClose(Symbol(), trend_period,1) > PivotW1)                 
     
         {
           Print ("    - .    4   = ", iClose(Symbol(), enter_period,1), " Tenkan_1 = ", Tenkan_1, 
                  "     = ", iClose(Symbol(), signal_period,1), " PivotD1 = ", PivotD1, " flet = ", flet, " FiltrPivot = ", FiltrPivot);
           Print ("     = ", iClose(Symbol(), trend_period,1), " PivotW1 = ", PivotW1);
           return(10);                      //  Buy    
         }
  
   
   if (Mas_Tip[1]==0 && //       
         flet >= FiltrPivot && iClose(Symbol(), enter_period,1) < Tenkan_1 && 
            iClose(Symbol(), signal_period,1) < PivotD1 && 
                  iClose(Symbol(), trend_period,1) < PivotW1)                 
     
         {
           Print ("     - .    4   = ", iClose(Symbol(), enter_period,1), " Tenkan_1 = ", Tenkan_1, 
                  "     = ", iClose(Symbol(), signal_period,1), " PivotD1 = ", PivotD1, " flet = ", flet, " FiltrPivot = ", FiltrPivot);
           Print ("     = ", iClose(Symbol(), trend_period,1), " PivotW1 = ", PivotW1);
           return(20);                      //  Buy    
         }
  
  
  // ------------------------ --------------------------------------------------------------------------------
  if(Mas_Tip[0]!=0 &&                             //        
     iClose(Symbol(), signal_period,1) < PivotD1) //      SL       
     {
         Print ("     -   .     = ", iClose(Symbol(), signal_period,1), 
                " PivotD1 = ", PivotD1); 
         return(11); 
      }                                            //  Buy    
   
   if(Mas_Tip[1]!=0 &&                             //        ...
      iClose(Symbol(), signal_period,1) > PivotD1)
      {    
          Print ("     -   .     = ", iClose(Symbol(), signal_period,1), 
                " PivotD1 = ", PivotD1); 
          return(21);                      //  Sell         
      }    
//--------------------------------------------------------------- 6 --
   return(0);                          //   . 
  }
//--------------------------------------------------------------- 7 --

//    
int GetPeriod(int period)
{int periodres;
 switch(period)
  {
   case 1: periodres=1;break;
   case 2: periodres=5;break;
   case 3: periodres=15;break;
   case 4: periodres=30;break;
   case 5: periodres=60;break;
   case 6: periodres=240;break;
   case 7: periodres=1440;break;
   case 8: periodres=10080;break;
   default: periodres=1;break;
  }
return(periodres);
} 









